Index: XIOS/trunk/src/output/nc4_data_output.cpp
===================================================================
--- XIOS/trunk/src/output/nc4_data_output.cpp	(revision 488)
+++ XIOS/trunk/src/output/nc4_data_output.cpp	(revision 498)
@@ -842,103 +969,115 @@
          }
 
-         if (grid->hasAxis()) // 3D
-         {
-            CAxis* axis = grid->axis ;
-            CArray<double,3> field_data3D(domain->zoom_ni_srv,domain->zoom_nj_srv,axis->zoom_size) ;
-            if (!field->default_value.isEmpty()) field_data3D = field->default_value ;
-
-            field->outputField(field_data3D);
-
-            if (!field->prec.isEmpty() && field->prec==2) field_data3D=round(field_data3D) ;
-
-            switch (SuperClass::type)
+         try
+         {
+           if (grid->hasAxis()) // 3D
            {
-              case (MULTI_FILE) :
+              CAxis* axis = grid->axis ;
+              CArray<double,3> field_data3D(domain->zoom_ni_srv,domain->zoom_nj_srv,axis->zoom_size) ;
+              if (!field->default_value.isEmpty()) field_data3D = field->default_value ;
+
+              field->outputField(field_data3D);
+
+              if (!field->prec.isEmpty() && field->prec==2) field_data3D=round(field_data3D) ;
+
+              switch (SuperClass::type)
+             {
+                case (MULTI_FILE) :
+                {
+                   SuperClassWriter::writeData(field_data3D, fieldid, isCollective, field->getNStep()-1);
+                   if (wtime)
+                   {
+                     SuperClassWriter::writeData(time_data, timeAxisId, isCollective, field->getNStep()-1);
+                     SuperClassWriter::writeData(time_counter, string("time_counter"), isCollective, field->getNStep()-1);
+                     SuperClassWriter::writeData(time_counter_bound, timeBoundId, isCollective, field->getNStep()-1);
+                     SuperClassWriter::writeData(time_data_bound, timeAxisBoundId, isCollective, field->getNStep()-1);
+                   }
+                   break ;
+                }
+                case (ONE_FILE) :
+                {
+                   std::vector<StdSize> start(3) ;
+                   std::vector<StdSize> count(3) ;
+                   if (domain->isEmpty())
+                   {
+                     start[0]=0 ; start[1]=0 ; start[2]=0 ;
+                     count[0]=0 ; count[1]=0 ; start[2]=0 ;
+                   }
+                   else
+                   {
+  //                 start[2]=domain->zoom_ibegin_loc.getValue()-domain->zoom_ibegin.getValue() ; start [1]=domain->zoom_jbegin_loc.getValue()-domain->zoom_jbegin.getValue() ; start[0]=0 ;
+                     start[2]=domain->zoom_ibegin_srv-domain->zoom_ibegin.getValue() ; start [1]=domain->zoom_jbegin_srv-domain->zoom_jbegin.getValue() ; start[0]=0 ;
+                     count[2]=domain->zoom_ni_srv ; count[1]=domain->zoom_nj_srv ; count[0] = axis->zoom_size.getValue();
+                   }
+                   SuperClassWriter::writeData(field_data3D, fieldid, isCollective, field->getNStep()-1,&start,&count );
+                   if (wtime)
+                   {
+                     SuperClassWriter::writeTimeAxisData(time_data, timeAxisId, isCollective, field->getNStep()-1,isRoot );
+                     SuperClassWriter::writeTimeAxisData(time_counter, string("time_counter"), isCollective, field->getNStep()-1,isRoot );
+                     SuperClassWriter::writeTimeAxisData(time_counter_bound, timeBoundId, isCollective, field->getNStep()-1, isRoot );
+                     SuperClassWriter::writeTimeAxisData(time_data_bound, timeAxisBoundId, isCollective, field->getNStep()-1, isRoot);
+                   }
+                   break;
+                }
+              }
+
+           }
+           else // 2D
+           {
+              CArray<double,2> field_data2D(domain->zoom_ni_srv,domain->zoom_nj_srv) ;
+              if (!field->default_value.isEmpty()) field_data2D = field->default_value ;
+              field->outputField(field_data2D);
+              if (!field->prec.isEmpty() && field->prec==2) field_data2D=round(field_data2D) ;
+              switch (SuperClass::type)
               {
-                 SuperClassWriter::writeData(field_data3D, fieldid, isCollective, field->getNStep()-1);
-                 if (wtime)
-                 {
-                   SuperClassWriter::writeData(time_data, timeAxisId, isCollective, field->getNStep()-1);
-                   SuperClassWriter::writeData(time_counter, string("time_counter"), isCollective, field->getNStep()-1);
-                   SuperClassWriter::writeData(time_counter_bound, timeBoundId, isCollective, field->getNStep()-1);
-                   SuperClassWriter::writeData(time_data_bound, timeAxisBoundId, isCollective, field->getNStep()-1);
-                 }
-                 break ;
+                case (MULTI_FILE) :
+                {
+                  SuperClassWriter::writeData(field_data2D, fieldid, isCollective, field->getNStep()-1);
+                  if (wtime)
+                  {
+                    SuperClassWriter::writeData(time_data, timeAxisId, isCollective, field->getNStep()-1);
+                    SuperClassWriter::writeData(time_counter, string("time_counter"), isCollective, field->getNStep()-1);
+                    SuperClassWriter::writeData(time_counter_bound, timeBoundId, isCollective, field->getNStep()-1);
+                    SuperClassWriter::writeData(time_data_bound, timeAxisBoundId, isCollective, field->getNStep()-1);
+                  }
+                  break;
+                }
+                case (ONE_FILE) :
+                {
+                   std::vector<StdSize> start(2) ;
+                   std::vector<StdSize> count(2) ;
+                   if (domain->isEmpty())
+                   {
+                     start[0]=0 ; start[1]=0 ;
+                     count[0]=0 ; count[1]=0 ;
+                   }
+                   else
+                   {
+                     start[1]=domain->zoom_ibegin_srv-domain->zoom_ibegin.getValue() ; start[0]=domain->zoom_jbegin_srv-domain->zoom_jbegin.getValue() ;
+                     count[1]=domain->zoom_ni_srv ; count[0]=domain->zoom_nj_srv ;
+                   }
+
+                   SuperClassWriter::writeData(field_data2D, fieldid, isCollective, field->getNStep()-1,&start,&count);
+                   if (wtime)
+                   {
+                     SuperClassWriter::writeTimeAxisData(time_data, timeAxisId, isCollective, field->getNStep()-1,isRoot);
+                     SuperClassWriter::writeTimeAxisData(time_counter, string("time_counter"), isCollective, field->getNStep()-1,isRoot);
+                     SuperClassWriter::writeTimeAxisData(time_counter_bound, timeBoundId, isCollective, field->getNStep()-1, isRoot);
+                     SuperClassWriter::writeTimeAxisData(time_data_bound, timeAxisBoundId, isCollective, field->getNStep()-1, isRoot);
+                   }
+                   break;
+
+                }
               }
-              case (ONE_FILE) :
-              {
-                 std::vector<StdSize> start(3) ;
-                 std::vector<StdSize> count(3) ;
-                 if (domain->isEmpty())
-                 {
-                   start[0]=0 ; start[1]=0 ; start[2]=0 ;
-                   count[0]=0 ; count[1]=0 ; start[2]=0 ;
-                 }
-                 else
-                 {
-//                 start[2]=domain->zoom_ibegin_loc.getValue()-domain->zoom_ibegin.getValue() ; start [1]=domain->zoom_jbegin_loc.getValue()-domain->zoom_jbegin.getValue() ; start[0]=0 ;
-                   start[2]=domain->zoom_ibegin_srv-domain->zoom_ibegin.getValue() ; start [1]=domain->zoom_jbegin_srv-domain->zoom_jbegin.getValue() ; start[0]=0 ;
-                   count[2]=domain->zoom_ni_srv ; count[1]=domain->zoom_nj_srv ; count[0] = axis->zoom_size.getValue();
-                 }
-                 SuperClassWriter::writeData(field_data3D, fieldid, isCollective, field->getNStep()-1,&start,&count );
-                 if (wtime)
-                 {
-                   SuperClassWriter::writeTimeAxisData(time_data, timeAxisId, isCollective, field->getNStep()-1,isRoot );
-                   SuperClassWriter::writeTimeAxisData(time_counter, string("time_counter"), isCollective, field->getNStep()-1,isRoot );
-                   SuperClassWriter::writeTimeAxisData(time_counter_bound, timeBoundId, isCollective, field->getNStep()-1, isRoot );
-                   SuperClassWriter::writeTimeAxisData(time_data_bound, timeAxisBoundId, isCollective, field->getNStep()-1, isRoot);
-                 }
-                 break;
-              }
-            }
-
-         }
-         else // 2D
-         {
-            CArray<double,2> field_data2D(domain->zoom_ni_srv,domain->zoom_nj_srv) ;
-            if (!field->default_value.isEmpty()) field_data2D = field->default_value ;
-            field->outputField(field_data2D);
-            if (!field->prec.isEmpty() && field->prec==2) field_data2D=round(field_data2D) ;
-            switch (SuperClass::type)
-            {
-              case (MULTI_FILE) :
-              {
-                SuperClassWriter::writeData(field_data2D, fieldid, isCollective, field->getNStep()-1);
-                if (wtime)
-                {
-                  SuperClassWriter::writeData(time_data, timeAxisId, isCollective, field->getNStep()-1);
-                  SuperClassWriter::writeData(time_counter, string("time_counter"), isCollective, field->getNStep()-1);
-                  SuperClassWriter::writeData(time_counter_bound, timeBoundId, isCollective, field->getNStep()-1);
-                  SuperClassWriter::writeData(time_data_bound, timeAxisBoundId, isCollective, field->getNStep()-1);
-                }
-                break;
-              }
-              case (ONE_FILE) :
-              {
-                 std::vector<StdSize> start(2) ;
-                 std::vector<StdSize> count(2) ;
-                 if (domain->isEmpty())
-                 {
-                   start[0]=0 ; start[1]=0 ;
-                   count[0]=0 ; count[1]=0 ;
-                 }
-                 else
-                 {
-                   start[1]=domain->zoom_ibegin_srv-domain->zoom_ibegin.getValue() ; start[0]=domain->zoom_jbegin_srv-domain->zoom_jbegin.getValue() ;
-                   count[1]=domain->zoom_ni_srv ; count[0]=domain->zoom_nj_srv ;
-                 }
-
-                 SuperClassWriter::writeData(field_data2D, fieldid, isCollective, field->getNStep()-1,&start,&count);
-                 if (wtime)
-                 {
-                   SuperClassWriter::writeTimeAxisData(time_data, timeAxisId, isCollective, field->getNStep()-1,isRoot);
-                   SuperClassWriter::writeTimeAxisData(time_counter, string("time_counter"), isCollective, field->getNStep()-1,isRoot);
-                   SuperClassWriter::writeTimeAxisData(time_counter_bound, timeBoundId, isCollective, field->getNStep()-1, isRoot);
-                   SuperClassWriter::writeTimeAxisData(time_data_bound, timeAxisBoundId, isCollective, field->getNStep()-1, isRoot);
-                 }
-                 break;
-
-              }
-            }
+           }
+         }
+         catch (CNetCdfException& e)
+         {
+           StdString msg("On writing field data: ");
+           msg.append(fieldid); msg.append("\n");
+           msg.append("In the context : ");
+           msg.append(context->getId()); msg.append("\n");
+           msg.append(e.what());
+           ERROR("CNc4DataOutput::writeFieldData_ (CField*  field)", << msg);
          }
       }
@@ -973,57 +1112,70 @@
          }
 
-         // Adding time_instant or time_centered
-         std::vector<StdString> dims;
-         dims.push_back(timeid);
-         if (!SuperClassWriter::varExist(axisid))
-         {
-            SuperClassWriter::addVariable(axisid, NC_DOUBLE, dims);
-
-            CDate timeOrigin=cal->getTimeOrigin() ;
-            StdOStringStream oss2;
-//            oss2<<initDate.getYear()<<"-"<<initDate.getMonth()<<"-"<<initDate.getDay()<<" "
-//                <<initDate.getHour()<<"-"<<initDate.getMinute()<<"-"<<initDate.getSecond() ;
-            StdString strInitdate=oss2.str() ;
-            StdString strTimeOrigin=timeOrigin.toString() ;
-            this->writeTimeAxisAttributes
-               (axisid, cal->getType(),
-                StdString("seconds since ").append(strTimeOrigin),
-                strTimeOrigin, axisBoundId);
-         }
-
-         // Adding time_instant_bounds or time_centered_bounds variables
-         if (!SuperClassWriter::varExist(axisBoundId))
-         {
-            dims.clear() ;
-            dims.push_back(timeid);
-            dims.push_back(timeBoundId);
-            SuperClassWriter::addVariable(axisBoundId, NC_DOUBLE, dims);
-         }
-
-         // Adding time_counter
-         axisid = "time_counter" ;
-         axisBoundId = "time_counter_bounds" ;
-         dims.clear() ;
-         dims.push_back(timeid);
-         if (!SuperClassWriter::varExist(axisid))
-         {
-            SuperClassWriter::addVariable(axisid, NC_DOUBLE, dims);
-            SuperClassWriter::addAttribute("axis", string("T"), &axisid);
-            CDate timeOrigin=cal->getTimeOrigin() ;
-            StdString strTimeOrigin=timeOrigin.toString() ;
-
-            this->writeTimeAxisAttributes
-               (axisid, cal->getType(),
-                StdString("seconds since ").append(strTimeOrigin),
-                strTimeOrigin, axisBoundId);
-         }
-
-         // Adding time_counter_bound dimension
-         if (!SuperClassWriter::varExist(axisBoundId))
-         {
-            dims.clear();
-            dims.push_back(timeid);
-            dims.push_back(timeBoundId);
-            SuperClassWriter::addVariable(axisBoundId, NC_DOUBLE, dims);
+         try
+         {
+          // Adding time_instant or time_centered
+           std::vector<StdString> dims;
+           dims.push_back(timeid);
+           if (!SuperClassWriter::varExist(axisid))
+           {
+              SuperClassWriter::addVariable(axisid, NC_DOUBLE, dims);
+
+              CDate timeOrigin=cal->getTimeOrigin() ;
+              StdOStringStream oss2;
+  //            oss2<<initDate.getYear()<<"-"<<initDate.getMonth()<<"-"<<initDate.getDay()<<" "
+  //                <<initDate.getHour()<<"-"<<initDate.getMinute()<<"-"<<initDate.getSecond() ;
+              StdString strInitdate=oss2.str() ;
+              StdString strTimeOrigin=timeOrigin.toString() ;
+              this->writeTimeAxisAttributes
+                 (axisid, cal->getType(),
+                  StdString("seconds since ").append(strTimeOrigin),
+                  strTimeOrigin, axisBoundId);
+           }
+
+           // Adding time_instant_bounds or time_centered_bounds variables
+           if (!SuperClassWriter::varExist(axisBoundId))
+           {
+              dims.clear() ;
+              dims.push_back(timeid);
+              dims.push_back(timeBoundId);
+              SuperClassWriter::addVariable(axisBoundId, NC_DOUBLE, dims);
+           }
+
+           // Adding time_counter
+           axisid = "time_counter" ;
+           axisBoundId = "time_counter_bounds" ;
+           dims.clear() ;
+           dims.push_back(timeid);
+           if (!SuperClassWriter::varExist(axisid))
+           {
+              SuperClassWriter::addVariable(axisid, NC_DOUBLE, dims);
+              SuperClassWriter::addAttribute("axis", string("T"), &axisid);
+              CDate timeOrigin=cal->getTimeOrigin() ;
+              StdString strTimeOrigin=timeOrigin.toString() ;
+
+              this->writeTimeAxisAttributes
+                 (axisid, cal->getType(),
+                  StdString("seconds since ").append(strTimeOrigin),
+                  strTimeOrigin, axisBoundId);
+           }
+
+           // Adding time_counter_bound dimension
+           if (!SuperClassWriter::varExist(axisBoundId))
+           {
+              dims.clear();
+              dims.push_back(timeid);
+              dims.push_back(timeBoundId);
+              SuperClassWriter::addVariable(axisBoundId, NC_DOUBLE, dims);
+           }
+         }
+         catch (CNetCdfException& e)
+         {
+           StdString msg("On writing time axis data: ");
+           msg.append("In the context : ");
+           CContext* context = CContext::getCurrent() ;
+           msg.append(context->getId()); msg.append("\n");
+           msg.append(e.what());
+           ERROR("CNc4DataOutput::writeTimeAxis_ (CField*    field, \
+                  const boost::shared_ptr<CCalendar> cal)", << msg);
          }
       }
@@ -1040,11 +1192,30 @@
                                                    const StdString & title)
       {
-         SuperClassWriter::addAttribute("standard_name", standard_name, &axis_name);
-         SuperClassWriter::addAttribute("long_name",     long_name    , &axis_name);
-         SuperClassWriter::addAttribute("title",         title        , &axis_name);
-         SuperClassWriter::addAttribute("calendar",      calendar     , &axis_name);
-         SuperClassWriter::addAttribute("units",         units        , &axis_name);
-         SuperClassWriter::addAttribute("time_origin",   time_origin  , &axis_name);
-         SuperClassWriter::addAttribute("bounds",        time_bounds  , &axis_name);
+         try
+         {
+           SuperClassWriter::addAttribute("standard_name", standard_name, &axis_name);
+           SuperClassWriter::addAttribute("long_name",     long_name    , &axis_name);
+           SuperClassWriter::addAttribute("title",         title        , &axis_name);
+           SuperClassWriter::addAttribute("calendar",      calendar     , &axis_name);
+           SuperClassWriter::addAttribute("units",         units        , &axis_name);
+           SuperClassWriter::addAttribute("time_origin",   time_origin  , &axis_name);
+           SuperClassWriter::addAttribute("bounds",        time_bounds  , &axis_name);
+         }
+         catch (CNetCdfException& e)
+         {
+           StdString msg("On writing time axis Attribute: ");
+           msg.append("In the context : ");
+           CContext* context = CContext::getCurrent() ;
+           msg.append(context->getId()); msg.append("\n");
+           msg.append(e.what());
+           ERROR("CNc4DataOutput::writeTimeAxisAttributes(const StdString & axis_name, \
+                                                   const StdString & calendar,\
+                                                   const StdString & units, \
+                                                   const StdString & time_origin, \
+                                                   const StdString & time_bounds, \
+                                                   const StdString & standard_name, \
+                                                   const StdString & long_name, \
+                                                   const StdString & title)", << msg);
+         }
       }
 
@@ -1058,9 +1229,26 @@
                                                const StdString & nav_model)
       {
-         SuperClassWriter::addAttribute("axis"         , axis         , &axis_name);
-         SuperClassWriter::addAttribute("standard_name", standard_name, &axis_name);
-         SuperClassWriter::addAttribute("long_name"    , long_name    , &axis_name);
-         SuperClassWriter::addAttribute("units"        , units        , &axis_name);
-         SuperClassWriter::addAttribute("nav_model"    , nav_model    , &axis_name);
+         try
+         {
+          SuperClassWriter::addAttribute("axis"         , axis         , &axis_name);
+          SuperClassWriter::addAttribute("standard_name", standard_name, &axis_name);
+          SuperClassWriter::addAttribute("long_name"    , long_name    , &axis_name);
+          SuperClassWriter::addAttribute("units"        , units        , &axis_name);
+          SuperClassWriter::addAttribute("nav_model"    , nav_model    , &axis_name);
+         }
+         catch (CNetCdfException& e)
+         {
+           StdString msg("On writing Axis Attribute: ");
+           msg.append("In the context : ");
+           CContext* context = CContext::getCurrent() ;
+           msg.append(context->getId()); msg.append("\n");
+           msg.append(e.what());
+           ERROR("CNc4DataOutput::writeAxisAttributes(const StdString & axis_name, \
+                                               const StdString & axis, \
+                                               const StdString & standard_name, \
+                                               const StdString & long_name, \
+                                               const StdString & units, \
+                                               const StdString & nav_model)", << msg);
+         }
       }
 
@@ -1070,8 +1258,22 @@
          (int ibegin, int ni, int jbegin, int nj, StdString domid)
       {
+        try
+        {
          SuperClassWriter::addAttribute(StdString("ibegin").append(domid), ibegin);
          SuperClassWriter::addAttribute(StdString("ni"    ).append(domid), ni);
          SuperClassWriter::addAttribute(StdString("jbegin").append(domid), jbegin);
          SuperClassWriter::addAttribute(StdString("nj"    ).append(domid), nj);
+        }
+        catch (CNetCdfException& e)
+        {
+           StdString msg("On writing Local Attributes: ");
+           msg.append("In the context : ");
+           CContext* context = CContext::getCurrent() ;
+           msg.append(context->getId()); msg.append("\n");
+           msg.append(e.what());
+           ERROR("CNc4DataOutput::writeLocalAttributes \
+                  (int ibegin, int ni, int jbegin, int nj, StdString domid)", << msg);
+        }
+
       }
 
@@ -1081,27 +1283,39 @@
          CArray<int,1> array(2) ;
 
-         SuperClassWriter::addAttribute("DOMAIN_number_total",size ) ;
-         SuperClassWriter::addAttribute("DOMAIN_number", rank) ;
-         array=1,2 ;
-         SuperClassWriter::addAttribute("DOMAIN_dimensions_ids",array) ;
-         array=ni_glo,nj_glo ;
-         SuperClassWriter::addAttribute("DOMAIN_size_global", array) ;
-         array=ni,nj ;
-         SuperClassWriter::addAttribute("DOMAIN_size_local", array) ;
-         array=ibegin,jbegin ;
-         SuperClassWriter::addAttribute("DOMAIN_position_first", array) ;
-         array=ibegin+ni-1,jbegin+nj-1 ;
-         SuperClassWriter::addAttribute("DOMAIN_position_last",array) ;
-         array=0,0 ;
-         SuperClassWriter::addAttribute("DOMAIN_halo_size_start", array) ;
-         SuperClassWriter::addAttribute("DOMAIN_halo_size_end", array);
-         SuperClassWriter::addAttribute("DOMAIN_type",string("box")) ;
-/*
-         SuperClassWriter::addAttribute("DOMAIN_DIM_N001",string("x")) ;
-         SuperClassWriter::addAttribute("DOMAIN_DIM_N002",string("y")) ;
-         SuperClassWriter::addAttribute("DOMAIN_DIM_N003",string("axis_A")) ;
-         SuperClassWriter::addAttribute("DOMAIN_DIM_N004",string("time_counter")) ;
-*/
-
+         try
+         {
+           SuperClassWriter::addAttribute("DOMAIN_number_total",size ) ;
+           SuperClassWriter::addAttribute("DOMAIN_number", rank) ;
+           array=1,2 ;
+           SuperClassWriter::addAttribute("DOMAIN_dimensions_ids",array) ;
+           array=ni_glo,nj_glo ;
+           SuperClassWriter::addAttribute("DOMAIN_size_global", array) ;
+           array=ni,nj ;
+           SuperClassWriter::addAttribute("DOMAIN_size_local", array) ;
+           array=ibegin,jbegin ;
+           SuperClassWriter::addAttribute("DOMAIN_position_first", array) ;
+           array=ibegin+ni-1,jbegin+nj-1 ;
+           SuperClassWriter::addAttribute("DOMAIN_position_last",array) ;
+           array=0,0 ;
+           SuperClassWriter::addAttribute("DOMAIN_halo_size_start", array) ;
+           SuperClassWriter::addAttribute("DOMAIN_halo_size_end", array);
+           SuperClassWriter::addAttribute("DOMAIN_type",string("box")) ;
+  /*
+           SuperClassWriter::addAttribute("DOMAIN_DIM_N001",string("x")) ;
+           SuperClassWriter::addAttribute("DOMAIN_DIM_N002",string("y")) ;
+           SuperClassWriter::addAttribute("DOMAIN_DIM_N003",string("axis_A")) ;
+           SuperClassWriter::addAttribute("DOMAIN_DIM_N004",string("time_counter")) ;
+  */
+         }
+         catch (CNetCdfException& e)
+         {
+           StdString msg("On writing Local Attributes IOI PSL \n");
+           msg.append("In the context : ");
+           CContext* context = CContext::getCurrent() ;
+           msg.append(context->getId()); msg.append("\n");
+           msg.append(e.what());
+           ERROR("CNc4DataOutput::writeLocalAttributes_IOIPSL \
+                  (int ibegin, int ni, int jbegin, int nj, int ni_glo, int nj_glo, int rank, int size)", << msg);
+         }
       }
       //---------------------------------------------------------------
@@ -1113,9 +1327,25 @@
                                                 const StdString & timeStamp)
       {
-         SuperClassWriter::addAttribute("name"       , name);
-         SuperClassWriter::addAttribute("description", description);
-         SuperClassWriter::addAttribute("conventions", conventions);
-         SuperClassWriter::addAttribute("production" , production);
-         SuperClassWriter::addAttribute("timeStamp"  , timeStamp);
+         try
+         {
+           SuperClassWriter::addAttribute("name"       , name);
+           SuperClassWriter::addAttribute("description", description);
+           SuperClassWriter::addAttribute("conventions", conventions);
+           SuperClassWriter::addAttribute("production" , production);
+           SuperClassWriter::addAttribute("timeStamp"  , timeStamp);
+         }
+         catch (CNetCdfException& e)
+         {
+           StdString msg("On writing File Attributes \n ");
+           msg.append("In the context : ");
+           CContext* context = CContext::getCurrent() ;
+           msg.append(context->getId()); msg.append("\n");
+           msg.append(e.what());
+           ERROR("CNc4DataOutput:: writeFileAttributes(const StdString & name, \
+                                                const StdString & description, \
+                                                const StdString & conventions, \
+                                                const StdString & production, \
+                                                const StdString & timeStamp)", << msg);
+         }
       }
 
@@ -1129,9 +1359,26 @@
                                                int data_jbegin)
       {
-         SuperClassWriter::addAttribute("data_dim"   , data_dim   , &mask_name);
-         SuperClassWriter::addAttribute("data_ni"    , data_ni    , &mask_name);
-         SuperClassWriter::addAttribute("data_nj"    , data_nj    , &mask_name);
-         SuperClassWriter::addAttribute("data_ibegin", data_ibegin, &mask_name);
-         SuperClassWriter::addAttribute("data_jbegin", data_jbegin, &mask_name);
+         try
+         {
+           SuperClassWriter::addAttribute("data_dim"   , data_dim   , &mask_name);
+           SuperClassWriter::addAttribute("data_ni"    , data_ni    , &mask_name);
+           SuperClassWriter::addAttribute("data_nj"    , data_nj    , &mask_name);
+           SuperClassWriter::addAttribute("data_ibegin", data_ibegin, &mask_name);
+           SuperClassWriter::addAttribute("data_jbegin", data_jbegin, &mask_name);
+         }
+         catch (CNetCdfException& e)
+         {
+           StdString msg("On writing Mask Attributes \n ");
+           msg.append("In the context : ");
+           CContext* context = CContext::getCurrent() ;
+           msg.append(context->getId()); msg.append("\n");
+           msg.append(e.what());
+           ERROR("CNc4DataOutput::writeMaskAttributes(const StdString & mask_name, \
+                                               int data_dim, \
+                                               int data_ni, \
+                                               int data_nj, \
+                                               int data_ibegin, \
+                                               int data_jbegin)", << msg);
+         }
       }
 
Index: XIOS/trunk/src/output/netCdfException.hpp
===================================================================
--- XIOS/trunk/src/output/netCdfException.hpp	(revision 498)
+++ XIOS/trunk/src/output/netCdfException.hpp	(revision 498)
@@ -0,0 +1,34 @@
+/*!
+   \file netCdfException.hpp
+   \author Ha NGUYEN
+   \date 08 Oct 2014
+   \since 07 Oct 2014
+
+   \brief Exception management.
+ */
+#ifndef __NETCDF_EXCEPTION_HPP__
+#define __NETCDF_EXCEPTION_HPP__
+
+#include <iostream>
+#include <exception>
+
+namespace xios
+{
+/*!
+\class CNetCdfException
+ This class manages exceptions risen by CNetCdfInterface
+*/
+class CNetCdfException : public virtual std::exception
+{
+public:
+  CNetCdfException(const std::string& ss) : exStr_(ss) {}
+  CNetCdfException(const CNetCdfException& netEx) : exStr_(netEx.exStr_) {}
+  ~CNetCdfException() throw() {}
+  const char* what() const throw() { return exStr_.c_str();}
+protected:
+  std::string exStr_;
+};
+
+}
+
+#endif // __NETCDF_EXCEPTION_HPP__
